
(function(window, undefined) {
         
   Vue.component("iwtree-item", {
     template: "#iwtree-item-template",
     props: {
        item: Object
     },
     data: function() {
       return {
         isOpen: true
       }
     },
     computed: {
       hasChildren : function() {
         return this.item.references;
       }
     },
     methods: {
      toggle: function () {
        this.isOpen = !this.isOpen
      }
     }
   
   });
   
   iw.record = new Vue({
      el: '#record-app',
      data : {
         defaultRefreshInterval : 2000,  //in milliseconds
         message                : "",
         config                 : {},
         info                   : {},
         license                : {
            product             : "IwTest",
            version             : "1.*",
            licensee            : "",
            type                : "",
            "valid-until"       : "",
            "valid-until-ts"    : -1,
            valid               : true,
            expired             : false,
            "version-ok"        : true,
            "days-left"         : -1
         },
         product :  {
           name                : "",
           version             : "",
           "latest-version"    : "",
           "latest-check-date" : "",
           "installation-date" : "",
           "installation-ts"   : 0
         },         
         showrecorddialog       : false,
         showgeneratedialog     : false,
         showrecordedservices   : false,
         showrundata            : false,
         success                : true,
         alias                  : "",
         availableAliases       : [],
         packageName            : "",
         localPackages          : [],
         packages               : [],
         serviceName            : "",
         services               : [],
         filteredServices       : [],
         servicesText           : "",
         selected               : false,
         referencedServices     : [],
     filteredReferencedServices : [],
         stubbedServices        : [],
         recordedServiceData    : {
                                   name: "",
                                   exists: false,
                                   package: "",
                                   active: false,
                                   stubs: [],
                                   runs: []
                                },
         recordedRunData        : {},
         servers                : {}, // 
         /*
           {"alias1" : {"is-enabled" : true,
                        "recording-config" :
                          [
                            { "service" : "service1",
                              "stubs"   : ["stub1", "stub2"]
                             },
                          
                          ]
                        }
           }
         */
         generateParams         : {
             alias                  : "",
             serviceName            : "",
             remoteThisAlias        : "",
             testSuiteServiceName   : "",
             targetPackage          : "",
             testSuiteName          : "",
             mode                   : "",
         },
         generateDefaultPackage : "",
         generateDefaultService : "",
         generateServiceMessage : "",
         targetTestSuiteServiceExists : false,
         targetPackageExists : false
      },
    methods : {      
      addRemoveStubbedService : function(item) {
        iw.log("Add/Remove Stubbed Service called", 3);
        iw.log(item, 4);
        iw.log(event, 4)
        if(event.srcElement.checked) {
          iw.log("Added " + item.service + " to stubbed services", 3);
          iw.record.stubbedServices.push(item.service);
        } else {
          iw.log("Removed" + item.service + " form stubbed services", 3);
          iw.record.stubbedServices = iw.record.stubbedServices.filter(s => {return s !== item.service})
        }
      },
      //Use this function for showing the result of actions, not for data retrieval
      response :function(data) {
         iw.log("Logging response from IS", 4);
         iw.log(data, 4);
         iw.record.showMessage(data["$message"], data["$success"] === "true" , 2500);
         iw.record.success = data["$success"] === "true" ? true : false;
         //iw.record.getRecordingState();
      },
 
      error : function(msg) { 
        iw.log(msg, 0);
        iw.record.showMessage(msg, false , 2500);       
      },      
      
      showMessage : function(msg, success, timeout) {  
         iw.record.message = msg;
         iw.record.success = success;
         if(typeof(timeout) === "number") {
            setTimeout(function(){iw.record.message=""}, timeout);

         }
      },
      
      hideMessage : function() {
         iw.record.message = "";
      },
      
      getConfig : function() {
         iw.invoke("iw.test.config:get", {}, function(data) {
            iw.record.config = data;    
            iw.record.listAliases();
            iw.record.listPackages();
         }, iw.record.error);
      },
      
      getInfo : function() {
         iw.invoke("iw.test.admin:info", {}, function(data) {
            iw.record.info    = data.license;
            iw.record.product = data.product;
         }, iw.record.error);
      },
      	
      listAliases: function() {
        let localAlias = "(local)";
        if(iw.record.config["ui.distributed.enabled"] === "false") {

            iw.record.availableAliases = [localAlias];         
            Vue.set(iw.record.servers, localAlias, {});
            iw.record.getRecordingState(localAlias); 
        } else {
          iw.invoke("iw.test.alias:list", {}, function(data) {
            iw.record.availableAliases = data.aliases.map(function(a){return a.split(":")[0]});
            iw.record.availableAliases.unshift(localAlias );
            //iw.record.getConfig();
            for(var i = 0; i < iw.record.availableAliases.length ; i++ ) {              
              Vue.set(iw.record.servers, iw.record.availableAliases[i], {});
              iw.record.getRecordingState(iw.record.availableAliases[i]);                            
            }
            
         }, iw.record.error);         
        }

		},
		
		listPackages : function(alias, showRecordPanel) {
		   var params = {"$alias": alias};
		   iw.invoke("iw.test.ui.ns:listPackages", params, function(data) {
		      iw.log("Retrieved packages for " + alias, 3);

            iw.record.packages = data.packages.filter(function(a){                 
                 var result = a["system-package"] !== "true" && a.enabled === "true";                 
                 return result;
            }).sort(function(a,b){ if(a.name >= b.name) return 1; else return -1});
            if(alias === undefined || alias === '' || alias === 'local' || alias === '(local)') {
                iw.record.localPackages = data.packages.sort(function(a,b){if(a.name >= b.name) return 1; else return -1});              
              }    
            if(showRecordPanel) iw.record.showrecorddialog = true
         }, iw.record.error);
		},
		
		clearServices : function() {
		   iw.record.selected = false;
		   iw.record.referencedServices = [];
		   iw.record.filteredReferencedServices = [];
		},
		
		listReferencedServices: function(serviceName) {
		    iw.record.serviceName = serviceName;
		    iw.log("Retrieving referenced services for: "+ serviceName, 3);
		    var params = {"service-name" : serviceName, "$alias" : iw.record.alias};
		    iw.log(params, 3);
		    iw.invoke("iw.test.ui.ns:getReferencedServices", params, function(data) {
		        iw.log(data, 4);
		        iw.record.referencedServices = data.references;
		        iw.record.filteredReferencedServices = data["filtered-references"];
		    }, iw.record.error);		    
		},
		
		hideRecordInput : function() {
		    iw.record.showrecorddialog = false;
		    iw.record.packageName = "";
		    iw.record.filteredServices = [];
		},
		
		showRecordInput : function(serviceName, packageName, alias) {
		   iw.log("Showing record input; serviceName: " + serviceName + "; packageName: " + packageName + "; alias: " + alias, 3);
		   iw.record.packageName = packageName;
		   iw.record.serviceName = serviceName;
		   iw.record.alias = alias;
 		   iw.record.listPackages(alias, true);            //iw.record.showrecorddialog = true;  		
		   iw.record.listReferencedServices(serviceName);   
		},		
		
		startServiceRecording : function(alias) {
   	    iw.log("Starting service recording for " + iw.record.serviceName, 3);
          var params = {"$alias": alias, "service": iw.record.serviceName, "stubs": iw.record.stubbedServices};
		    iw.invoke("iw.test.ui.record:on", params, iw.record.response, iw.record.error);
		    if(! iw.record.servers[alias]["is-enabled"]) {
		      iw.record.startRecordingAgent(alias);
		    }
		    iw.record.serviceName = "";
		    iw.record.stubbedServices = [];
		    iw.record.filteredServices = [];
		    iw.record.servicesText = "";
		    iw.record.selected = false;
		    iw.record.referencedServices = [];
		    iw.record.filteredReferencedServices = [];
  		    iw.record.showrecorddialog = false;
		},
		
		stopServiceRecording : function(serviceName, alias) {
		    iw.log("Stopping service recording for " + serviceName + " on " + alias, 3);
		    var params = {"$alias" : alias, "service": serviceName};
		    iw.invoke("iw.test.ui.record:off", params, iw.record.response, iw.record.error);
		    
		    //Refresh the table in case automatic refresh is not active
		    if(! iw.record.servers[alias]["is-enabled"]) {
		      iw.record.getRecordingState(alias); 
		    } 
		},
		
		deleteRecordedData : function(serviceName, alias) {
		    var params = {"$alias" : alias, "service-name" : serviceName};
		    iw.invoke("iw.test.ui.testrun:remove", params, iw.record.response, iw.record.error);
		    iw.log("[delete recorded data] server: " + alias + "; service: " + serviceName + "; iw.record.servers[alias][is-enabled]: " + iw.record.servers[alias]["is-enabled"], 3)
		  
		    //Refresh the table in case automatic refresh is not active
		    if(! iw.record.servers[alias]["is-enabled"]) {
		      iw.record.getRecordingState(alias); 
		    } 
		  
		},		
		
		startGetRecordingState : function(alias) {
		   var refreshInterval = Number(iw.record.config["record.sample.interval.ms"]);
		   let id = iw.record.servers[alias]["scheduled-service-id"];
		   
		   if(id == undefined) {
         if(refreshInterval < iw.record.defaultRefreshInterval) refreshInterval = iw.record.defaultRefreshInterval;
         iw.record.getRecordingState(alias);
         id = window.setInterval(function() {iw.record.getRecordingState(alias)}, refreshInterval);
         Vue.set(iw.record.servers[alias], "scheduled-service-id" , id);
         iw.log("Scheduled 'getRecordingState()'; alias: " + alias + "; id: " + id + "; interval: " + refreshInterval, 3);
      } else {
        iw.log("'getRecordingState()' for alias " + alias + " is already running. id: " + id, 3)
      }
		},
		
		stopGetRecordingState: function(alias) {
		   var id = iw.record.servers[alias]["scheduled-service-id"];
      
		   window.clearInterval(id);
		   Vue.delete(iw.record.servers[alias], "scheduled-service-id"); 
		   iw.log("Unscheduled 'getRecordingState()'; alias: " + alias + "; id: " + id, 3);
		},		
		
		startRecordingAgent : function(alias) {
		   
		   iw.log("Starting recording on :'" + alias + "'", 3);
		   var params = {"$alias" : alias};
		   iw.invoke("iw.test.ui.record:enable", params, iw.record.response, iw.record.error);
		   iw.record.startGetRecordingState(alias);
		},	
		
		stopRecordingAgent : function(alias) {
		   iw.log("Stopping recording on :'" + alias + "'", 3);
		   var params = {"$alias" : alias};
		   iw.invoke("iw.test.ui.record:disable", params, iw.record.response, iw.record.error);	
		   iw.record.stopGetRecordingState(alias);
		   iw.record.getRecordingState(alias);
		},
		
		getRecordingState : function(alias) {

           var params = {};
           if(alias !== undefined) {
              params = {"$alias": alias};
           }
           iw.log("Calling 'getRecordingState'; alias: " + alias, 3);
           iw.invoke("iw.test.ui.testrun:list", params, function(data) {    
                
                if(data.$success === 'false') {                                 
                   Vue.set(iw.record.servers[data.$alias], "available", false);
                   Vue.set(iw.record.servers[data.$alias], "error-message", data.$message);
                 } else {
                   Vue.set(iw.record.servers[data.$alias], "available", true);
                   Vue.set(iw.record.servers[data.$alias], "services", data.services);
                   var params2 = {"$alias" : data.$alias};
                   iw.invoke("iw.test.ui.record:status", params2, function(data) {                       
                     Vue.set(iw.record.servers[data.$alias], "is-enabled", data.enabled === "true" ? true : false );
                     if(data.running === "true" && iw.record.servers[data.$alias]["scheduled-service-id"] === undefined) {
                        iw.record.startGetRecordingState(data.$alias);
                     }
                  });
                }
             }, iw.record.error);
	    	 
		},	    	
		
		showGenerateInput : function(alias, serviceName, packageName) {
		      var params = { "$alias": alias, "service-name" : serviceName, "package" : packageName};
		      iw.log("Show Generate input: $alias: " + alias + "; serviceName: " + packageName + "/" + serviceName, 3);
		      iw.invoke("iw.test.generate.service:getDefaults", params, function(data) {
		         iw.log(data, 4);
		         iw.log(this, 4);
		         if(data["$success"] === "false") {
		            iw.record.success = false;
		            iw.record.message = data["$message"];
		            setTimeout(function(){iw.record.message=""}, 5000);
		         } else {
		            iw.record.generateDefaultPackage              = packageName;
		            iw.record.generateDefaultService              = serviceName	
		            iw.record.generateParams.alias                = alias === "(local)" ? "" : alias;
		            iw.record.generateParams.serviceName          = serviceName;
		            iw.record.generateParams.remoteThisAlias      = "";
		            iw.record.generateParams.targetPackage        = data.defaults["target-package"];
		            iw.record.generateParams.testSuiteName        = data.defaults["test-suite-name"];
		            iw.record.generateParams.testSuiteServiceName = data.defaults["test-suite-service-name"];		            
		            iw.record.generateParams.mode                 = data.defaults["mode"];

		            iw.record.validateGenerateParams(iw.record.generateParams.testSuiteServiceName);
                  iw.record.showgeneratedialog             = true;
                  
                  iw.record.stopServiceRecording(serviceName, alias);
		         }
		      }, iw.record.error);
		},
		/*
		       alias                  : "",
             remoteThisAlias        : "",
             testSuiteServiceName"  : "",
             targetPackage          : "",
             testSuiteName          : "",
             mode		
      */
		
		generateTestSuite : function(generateParams) {
		
         var params = { "$alias"              : generateParams.alias,
                    "service-name"            : generateParams.serviceName,
                    "target-package"          : generateParams.targetPackage,
                    "test-suite-name"         : generateParams.testSuiteName,
                    "test-suite-service-name" : generateParams.testSuiteServiceName,
                    "mode"                    : generateParams.mode};
       iw.log("Calling iw.test.generate.pub:generateTestSuite with these parameters:", 4)
       iw.log(params, 4)
		   iw.invoke("iw.test.generate.pub:generateTestSuite", params, iw.record.response, iw.record.error);
		   iw.record.showgeneratedialog             = false;
		   
	    //Refresh the table in case automatic refresh is not active
		    if(iw.record.servers[generateParams.alias] && !iw.record.servers[generateParams.alias]["is-enabled"]) {
		      iw.record.getRecordingState(generateParams.alias); 
		    } 
		},				
		
		hideGenerateInput : function() {
		   iw.record.showgeneratedialog = false;
		},
		
		validateGenerateParams : function(nsname) {
         if(/(\w+)(\.\w+)*(:\w+)/.test(nsname)) {
            
            var params = {"nsname" : nsname};
            iw.invoke("iw.test.ui.ns:getLocalNode" , params , function(data){
                 iw.log(data, 4);
                 if(data.node.exists === true ) {
                    iw.record.targetTestSuiteServiceExists = true;
                    iw.record.generateParams.targetPackage = data.node.package;
                    if(data.node.node_type === "service" && data.node.svc_type === "flow") {
                        //that's ok, reset message
                        iw.record.generateServiceMessage = "";
                    } else {
                         iw.record.generateServiceMessage = "'" + nsname + "' exists, but is not a flow service!";		                
                    }
                 } else {
                          iw.record.targetTestSuiteServiceExists = false;
                          iw.record.generateServiceMessage = "";                          
                 }
            }, iw.record.error);
		   } else {
		      iw.record.generateServiceMessage = "Not a valid service name";
		      iw.record.targetTestSuiteServiceExists = false;
		       
		   }
		},
		
		packageExists : function(pkg) {
		    
		    return pkg && pkg.length > 0 && iw.record.localPackages.filter(function(a){return a.name === pkg}).length === 1;
		},
		
		showRecordedServiceRuns: function(alias, service) {
		
		   if(service.length > 0) {
		      var params = {"$alias" : alias, "service-name": service};
		      iw.invoke("iw.test.ui.testrun:list", params, function(data){
		         iw.log("List of test runs for service " + service, 3);
		         iw.log(data, 3);        
		         if(data.services.length > 0) {
		             iw.record.recordedServiceData = data.services[0];
		             iw.record.recordedServiceData.alias = alias;
		             iw.record.recordedServiceData.runs.sort(function(a, b) { return b["date-recorded"].localeCompare(a["date-recorded"])});
		             iw.record.showrecordedservices = iw.record.recordedServiceData.runs.length > 0;

		         } else {
   		         iw.record.showMessage("No recorded data found for '" + service + "'", false, 2500);

		         }
		         
		      }, iw.record.error);
		   }
		   		 			   
		},
		
		loadRunData: function(alias, service, id) {
		  iw.log("loadRunData: alias: " + alias + "; service: " + service + "; id: " + id + "; show: " + iw.record.showrundata, 3);
		
		  if(id === iw.record.recordedRunData.id) {
		     iw.record.showrundata = !iw.record.showrundata; //toggle visibility for the same run
		     
		  } else {		     		  

          if(service.length > 0) {
            var params = {"$alias" : alias, "service-name": service, "service-run-id": id};
            iw.invoke("iw.test.ui.testrun:get", params, function(data){
              if(data["$success"] === "true") {
                iw.record.recordedRunData = data["service-run"];
                iw.record.showrundata = true;
              } else {
                iw.record.showMessage("No run data found for '" + service + ":"+id, false, 2500);
              }            
            }, iw.record.error);
          }            		 
	     }         		
		},
		
		closeRunDataView: function() {
		   iw.record.showrecordedservices = false;
		   Vue.delete(iw.record.recordedRunData, "id");
		},
		
		deleteRunData: function(alias, service, id) {
		   iw.log("About to delete run '" + id + " for service " + service + " on " + alias, 3);
		   var params = {"$alias" : alias, "service-name": service, "service-run-id": id};
		   iw.invoke("iw.test.ui.testrun:remove", params, function(data){
              if(data["$success"] === "true") {
                 iw.record.showRecordedServiceRuns(alias, service)
              } else {
                iw.record.showMessage(data["$message"],  false, 2500);
              }            
            });
		}
		
		
    }

  });
    
   iw.record.getInfo();    
   iw.record.getConfig(); 
   
})(this, undefined);
      